import java.util.Scanner;

class Napoleon {

	private static Scanner scanner = new Scanner(System.in);

	public static void main(String[] args) {
		String noms = "Napoleon Bonaparte Bill Gates Claudia Schiffer Martina Hingis Jean Jean";
		System.out.print("Entrez le prenom de la personne a rechercher: ");
		String prenom = scanner.nextLine();

		/*
		 * La chaîne noms ne permet pas de distinguer facilement entre un
		 * nom et un prenom : il faudrait qu'une recherche de "Napoleon"
		 * retourne "Bonaparte", mais qu'une recherche de "Bonaparte" ne
		 * retourne pas "Bill" !)
		 * Pourquoi ne pas utiliser un tableau à la place:
		 *     String[][] nameList = new String [numberOfPersons][2];
		 * Un tableau à deux dimensions tel que nameList[i][0] contient
		 * le prénom de la personne i et nameListe[i][1] contient
		 * son nom.
		 */

		/*
		 * la méthode trim des Strings permet de supprimer les espaces
		 * en début et fin de chaîne.
		 */
		noms = noms.trim();

		/*
		 * Sachant qu'ici la liste de personnes n'est pas amenée à
		 * évoluer, on peut partir sur un tableau de taille fixe
		 * dont il s'agit maintenant de calculer la taille.
		 */
		int numberOfSpaces = 0;
		for (int i = 0; i < noms.length(); i++) {
			if (noms.charAt(i) == ' ') {
				numberOfSpaces++;
			}
		}

		/*
		 * On utilise ici le fait que le résultat de la division
		 * entière est toujours arrondi vers le bas. Il y a deux espaces
		 * par personne (un pour la séparer du prédécesseur et un pour séparer
		 * le nom du prénom), sauf pour le premier qui n'en a qu'un seul.
		 */
		int numberOfPersons = numberOfSpaces / 2 + 1;

		/*
		 * Maintenant on transfère la chaîne noms dans un tableau a deux
		 * dimensions
		 */
		String [][] nameList = new String [numberOfPersons][2];

		int stringPos = 0;
		for (int pers = 0; pers < numberOfPersons; pers++) {
			// Lecture du prénom
			int prenameEnd = noms.indexOf(' ', stringPos);
			if (prenameEnd == -1) {
				prenameEnd = noms.length();
			}
			nameList [pers][0] = noms.substring(stringPos, prenameEnd);
			stringPos = prenameEnd + 1;

			//Lecture du nom
			int nameEnd = noms.indexOf(' ', stringPos);
			if (nameEnd == -1) {
				nameEnd = noms.length();
			}
			nameList [pers][1] = noms.substring(stringPos, nameEnd);
			stringPos = nameEnd + 1;
			
			/*
			 * NOTE: La répétiton de code ("source de tous les maux") qui
			 * précède pourra facilement être évitée en utilisant des
			 * méthodes auxiliaires. Voir le prochain cours.
			 */
		}

		/*
		Et enfin on peut mettre en oeuvre notre petit algorithme
		de recherche du nom associé à un prénom
		*/
		String name = null;
		int index = -1 ;
		// pour sophistiquer un peu l'affichage
		// Le fait de traiter les prénoms en premier permet au programme
		// de continuer à bien fonctionner même pour les personnes
		// ayant un nom et un prénom identique
		for (int pers = 0; pers < nameList.length && name == null; pers++) {
			if (nameList [pers][0].equals(prenom)) {
				name = nameList[pers][1];
			} else if (nameList[pers][1].equals(prenom)) {
				index = pers;
			}
		}
		if (name != null) {
			System.out.println("Le nom complet est: " + prenom + " " + name);
		} else if (index > -1) {
			System.out.println("Vous avez introduit un nom au lieu d'un prenom");
		} else {
			System.out.println("Inconnu au bataillon!");
		}
	}
}
